empty_command_line_test.sh 1.3 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243
  1. #!/bin/sh
  2. # empty_command_line_test.sh -- test various command lines with no inputs
  3. # Copyright (C) 2017-2022 Free Software Foundation, Inc.
  4. # Written by Benjamin Peterson <bp@benjamin.pe>
  5. # This file is part of gold.
  6. # This program is free software; you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation; either version 3 of the License, or
  9. # (at your option) any later version.
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. # You should have received a copy of the GNU General Public License
  15. # along with this program; if not, write to the Free Software
  16. # Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
  17. # MA 02110-1301, USA.
  18. check()
  19. {
  20. expected_msg="$1"
  21. shift
  22. echo "checking empty command line '$@'"
  23. err=$(gcctestdir/ld "$@" 2>&1)
  24. if [ $? != 1 ]; then
  25. echo "gold didn't fail"
  26. exit 1
  27. fi
  28. echo "$err" | grep -q "$expected_msg" || {
  29. echo "unexpected error message: $err"
  30. exit 1
  31. }
  32. }
  33. check "no input files"
  34. check "missing lib end" --start-lib
  35. check "missing group end" --start-group